#import "iUI8.h"
@import WebKit;

@interface B4IWKWebViewDelegate:NSObject <WKNavigationDelegate, WKUIDelegate>

@end

@implementation B4IWKWebViewDelegate
- (void)webView:(WKWebView *)webView didFinishNavigation:(WKNavigation *)navigation {
    [B4IObjectWrapper raiseUIEvent:webView :@"_pagefinished::" :@[@(true), webView.URL.absoluteString]];
}

- (void)webView:(WKWebView *)webView didFailNavigation:(WKNavigation *)navigation withError:(NSError *)error {
    [self webView:webView didFailProvisionalNavigation:navigation withError:error];
}

- (void)webView:(WKWebView *)webView didFailProvisionalNavigation:(WKNavigation *)navigation withError:(NSError *)error {
    [[B4I shared] setLastError:error];
    NSString* url = webView.URL.absoluteString;
    if (url == nil)
        url = error.userInfo[NSURLErrorFailingURLStringErrorKey];
    [B4IObjectWrapper raiseUIEvent:webView :@"_pagefinished::" :@[@(false), url]];
}

- (void)webView:(WKWebView *)webView decidePolicyForNavigationAction:(WKNavigationAction *)navigationAction decisionHandler:(void (^)(WKNavigationActionPolicy))decisionHandler {
    NSURL *url = navigationAction.request.URL;
    BOOL b;
    if ([url isFileURL] && [url isEqual:[NSURL fileURLWithPath:[B4ICommon shared].File.DirAssets]])
        b = true;
    else {
        NSObject *res = [B4IObjectWrapper raiseEvent:webView :@"_overrideurl:" :@[url.absoluteString]];
        b = res == nil ? true : ![(NSNumber *) res boolValue];
    }
    decisionHandler(b ? WKNavigationActionPolicyAllow : WKNavigationActionPolicyCancel);
}


@end


@implementation B4IWKWebvViewWrapper
#define OBJ ((WKWebView *) self.object)
+ (Class)getClass {
    return [WKWebView class];
}

- (NSString *)Title {
    return [[B4I shared] returnString:OBJ.title];
}

- (double)EstimatedProgress {
    return OBJ.estimatedProgress;
}

- (void)DesignerCreateView:(B4IPanelWrapper *)base :(B4ILabelWrapper *)lw :(B4IMap *)props {
    WKWebViewConfiguration *conf = [[WKWebViewConfiguration alloc] init];
    conf.suppressesIncrementalRendering = [(NSNumber *) [props Get:@"SuppressRendering"] boolValue];
    self.object = [[WKWebView alloc] initWithFrame:[(UIView*)base.object frame]
                                     configuration:conf];
    [B4IObjectWrapper setBIAndEventName:OBJ :[B4IObjectWrapper getBI:base.object] :[B4IObjectWrapper getEventName:base.object]];
    [base AddView:OBJ :0 :0 :base.Width :base.Height];
    B4IWKWebViewDelegate *del = [[B4IWKWebViewDelegate alloc] init];
    [B4IObjectWrapper getMap:OBJ][@"delegate"] = del;
    OBJ.navigationDelegate = del;

}

- (void)_initialize:(B4I *)bi2 :(NSObject *)target :(NSString *)EventName {
}

- (void)base_resize:(CGFloat)width :(CGFloat)height {
    [OBJ SetLayoutAnimated:0 :1 :0 :0 :width :height];
}
- (B4IViewWrapper *)BaseView {
    B4IWeakRef *ref = [B4IObjectWrapper getMap:OBJ][@"base"];
    return [B4IObjectWrapper createWrapper:[B4IPanelWrapper new] object:ref.Value];
}
- (void)LoadUrl:(NSString *)Url {
    [OBJ loadRequest:[NSURLRequest requestWithURL:[NSURL URLWithString:Url]]];
}
- (void)LoadHtml:(NSString *)Html {
    [OBJ loadHTMLString:Html baseURL:[NSURL fileURLWithPath:[B4ICommon shared].File.DirAssets]];
}
- (BOOL)CanGoBack {
    return OBJ.canGoBack;
}
- (BOOL)CanGoForward {
    return OBJ.canGoForward;
}
- (void)GoBack {
    [OBJ goBack];
}
- (void)GoForward {
    [OBJ goForward];
}
- (void)StopLoading {
    [OBJ stopLoading];
}
- (void)Reload {
    [OBJ reloadFromOrigin];
}
- (void)EvaluateJavaScript:(NSObject *)Tag : (NSString *)Script{
    [OBJ evaluateJavaScript:Script completionHandler:^(id o, NSError *error) {
        if (error != nil)
            [[B4I shared] setLastError:error];
        [B4IObjectWrapper raiseEvent:OBJ :@"_jscomplete:::" :@[@(error == nil), [B4I nilToNSNull:Tag], [B4I nilToNSNull:[o description]]]];
    }];
}

@end